<template>
  <div class="buy-heta">
    <div class="content">
      <div class="list-coin">
        <div class="coin-item" v-for="(coin, index) in listCoin" @click="selectCoin(index)" :class="{ 'active': isCurrentCoin(coin) }">
          <img :src="coin.srcImg" :alt="coin.fullname" class="coin__image">
          <span class="coin__name">{{ coin.name }}</span>
        </div>
      </div>

      <template>
        <div class="btc-box">
          <div class="exchange-rate-group rate">
            <div class="content-left">
              <div class="textbox">
                <span class="number">1</span>
                <span class="text">{{ currentCoin | uppercase }}</span>
                <span class="equal">&asymp;</span>
                <span class="number">{{ currencyToUsdPrice }}</span>
                <span class="text">USD</span>
              </div>
            </div>

            <div class="content-right">
              <div class="textbox">
                <span class="number">1</span>
                <span class="text">HETA Token</span>
                <span class="equal">&asymp;</span>
                <span class="number">{{ tokenToCurrencyPrice }}</span>
                <span class="text">{{ currentCoin | uppercase }}</span>
              </div>
            </div>
          </div>

          <div class="buy-heta__input-wrapper">
            <currency-input
              type="text"
              v-model="currencyValue"
              name='currency_amount'
              data-vv-as="currency amount"
              v-validate="currencyValidator"
              data-vv-validate-on="none"
              :disabled="!isAvailable"
              :precision="currentSetting ? currentSetting.currency_precision : 0"
              :placeholder="$t('dashboard.buy.enter_amount')"
              @focus="onFocusCurrency"
              @blur="onBlurCurrency"
              class="buy-heta__input"/>
            <span class="unit">{{ currentCoin | uppercase }}</span>
          </div>
          <span class="invalid-feedback" v-if="errors.has('currency_amount')">{{ errors.first('currency_amount') }}</span>

          <div class="exchange-rate-group">
            <div class="content-left">
              <div class="textbox">
                <span class="iconmo-wallet"></span>
                <span class="number fz-18">{{ currentWallet.available_balance | formatCurrencyAmount(currentCoin, 0) }}</span>
                <span class="text">{{ currentCoin | uppercase }}</span>
              </div>
            </div>

            <div class="content-right">
              <div class="btn-group">
                <span
                  class="btn-item"
                  v-for="(suggestion, index) in suggestedPercents"
                  :class="{ active: isCurrentSuggestion(index), disabled: !(isAvailable && isssetBalance) }"
                  @click="setCurrencyInput(index)">
                    {{ suggestion * 100 }}%
                </span>
              </div>
            </div>
          </div>

          <div class="buy-heta__input-wrapper">
            <currency-input
              type="text"
              v-model="tokenValue"
              name='token_amount'
              data-vv-as="token amount"
              v-validate="tokenValidator"
              data-vv-validate-on="none"
              :disabled="!isAvailable"
              :precision="currentSetting ? currentSetting.token_precision : 0"
              :placeholder="$t('dashboard.buy.enter_amount')"
              @focus="onFocusToken"
              @blur="onBlurToken"
              class="buy-heta__input"/>
            <span class="unit">HETA Token</span>
          </div>
          <span class="invalid-feedback" v-if="errors.has('token_amount')">{{ errors.first('token_amount') }}</span>

          <div class="expression" v-if="currentBonus && tokenValue > 0">
            <span class="number">{{ tokenValue | formatCurrencyAmount('heta', 0) }}</span>
            <span class="text">+</span>
            <span class="number">{{ bonusValue }}</span>
            <span class="text">{{ $t('dashboard.buy.bonus') }} = </span>
            <span class="number">{{ finalCurrencyValue }}</span>
            <span class="text">HETA Token</span>
          </div>
        </div>

        <div class="buy-btn-wrapper">
          <span class="buy-btn" :class="{ disabled: !isAvailable }" @click="buyToken">{{ $t('dashboard.buy.btn') }}</span>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
  import { mapState, mapGetters } from 'vuex';
  import BigNumber from 'bignumber.js';
  import rf from '../../../common/requests/RequestFactory';
  import CurrencyInput from '../../components/CurrencyInput.vue';
  import BuyTokenConfirmModal from '../../components/Modal/BuyTokenConfirmModal.vue';

  export default {
    components: {
      CurrencyInput
    },
    data() {
      return {
        currentCoin: 'btc',
        currencyValue: '',
        tokenValue: '',
        isCurrencyInputing: false,
        isTokenInputing: false,
        suggestedPercents: [0.25, 0.5, 0.75, 1],
        isSubmitting: false,
        listCoin: [
          {
            srcImg: '/images/icon/balanceImg/heta-btc-icon.png',
            name: 'btc',
            fullname: 'Bitcoin',
          },
          {
            srcImg: '/images/icon/balanceImg/heta-usdt-icon.png',
            name: 'usdt',
            fullname: 'TetherUS',
          },
          {
            srcImg: '/images/icon/balanceImg/heta-eth-icon.png',
            name: 'eth',
            fullname: 'Ethereum',
          },
        ],
      }
    },
    watch: {
      currentWallet() {
        this.tokenValue = '';
        this.currencyValue = '';
      },
      currencyValue() {
        this.calculateTokenValue();
      },
      tokenValue() {
        this.clearError();
        this.calculateCurrencyValue()
      },
    },
    computed: {
      ...mapState(['wallets', 'currentBonus', 'conversionSettings', 'prices']),
      ...mapGetters(['isCrowdsaling']),
      currentWallet() {
        if (!this.wallets || !this.currentCoin) {
          return {};
        }
        return this.wallets.find(wallet => wallet.currency === this.currentCoin) || {};
      },
      currentSetting() {
        return this.conversionSettings.find(setting => setting.currency === this.currentCoin);
      },
      suggestedAmounts() {
        return this.suggestedPercents.map(percent => {
          const amount = BigNumber(this.currentWallet.available_balance).times(percent);
          return this.formatCurrency(amount);
        });
      },
      tokenValidator() {
        const minToken = BigNumber(this.currentSetting ? this.currentSetting.min_token : 0);
        return `required|min_value:${this.formatToken(minToken)}`;
      },
      currencyValidator() {
        return 'required';
      },

      //EXCHANGE RATE - BEGIN
      currencyToUsdPrice() {
        return this.prices[this.currentCoin] || 0;
      },
      tokenToCurrencyPrice() {
        const tokenToUsdPrice = this.prices['heta'] || 0;
        const tokenToCurrencyprice = BigNumber(tokenToUsdPrice).div(this.currencyToUsdPrice);
        return this.formatCurrency(tokenToCurrencyprice);
      },
      //EXCHANGE RATE - END

      //EXPRESSION SECTION - BEGIN
      bonusValue() {
        const bonusValue = BigNumber(this.currentBonus.percent).times(this.tokenValue);
        return this.formatToken(bonusValue);
      },
      finalCurrencyValue() {
        const finalCurrencyValue = BigNumber(this.currentBonus.percent).plus(1).times(this.tokenValue);
        return this.formatToken(finalCurrencyValue);
      },
      isAvailable() {
        return this.currentSetting && this.currentWallet.available_balance && this.isCrowdsaling;
      },
      isssetBalance() {
        return this.currentWallet
          && this.$options.filters.formatCurrencyAmount(this.currentWallet.available_balance, this.currentWallet.currency, 0);
      },
      //EXPRESSION SECTION - END
    },
    methods: {
      selectCoin(index) {
        this.clearError();
        this.currentCoin = this.listCoin[index].name;
        if (this.$route.query.currency !== this.currentCoin) {
          this.$router.push({ query: { currency: this.currentCoin } });
        }
      },
      isCurrentCoin(coin) {
        return coin.name === this.currentCoin;
      },
      formatToken(amount) {
        if (!this.currentSetting) {
          return 0;
        }
        return amount.toFormat(this.currentSetting.token_precision, BigNumber.ROUND_DOWN);
      },
      formatCurrency(amount) {
        if (!this.currentSetting) {
          return 0;
        }
        return amount.toFormat(this.currentSetting.currency_precision, BigNumber.ROUND_UP);
      },
      clearError() {
        this.errors.clear();
      },

      //CALCULATE INFOCUS INPUT FIELD - BEGIN
      calculateTokenValue(forced = false) {
        const rawValue = BigNumber(this.currencyValue).div(this.tokenToCurrencyPrice);
        const tokenValue = this.formatToken(rawValue);
        if ((forced || this.isCurrencyInputing) && (this.tokenValue !== tokenValue)) {
          this.tokenValue = tokenValue;
        }
      },
      calculateCurrencyValue(forced = false) {
        const rawValue = BigNumber(this.tokenValue).times(this.tokenToCurrencyPrice);
        const currencyValue = this.formatCurrency(rawValue);
        if ((forced || this.isTokenInputing) && (this.currencyValue !== currencyValue)) {
          this.currencyValue = currencyValue;
        }
      },
      onFocusToken() {
        this.isTokenInputing = true;
      },
      onBlurToken() {
        this.isTokenInputing = false;
      },
      onFocusCurrency() {
        this.isCurrencyInputing = true;
      },
      onBlurCurrency() {
        this.isCurrencyInputing = false;
      },
      //CALCULATE INFOCUS INPUT FIELD - END
      
      //CURRENCY INPUT SUGGESTION - BEGIN
      setCurrencyInput(index) {
        if (!this.isssetBalance) {
          return;
        }
        this.currencyValue = this.suggestedAmounts[index];
        this.calculateTokenValue(true);
      },
      isCurrentSuggestion(index) {
        return index === this.suggestedAmounts.findIndex(amount => BigNumber(this.currencyValue).eq(amount));
      },
      //CURRENCY INPUT SUGGESTION - END

      //FORM SUBMITING - BEGIN
      buyToken() {
        if (!this.isAvailable || this.isSubmitting) {
          return;
        }
        this.$validator.validateAll().then(() => {
          this.validateBalance();
          if (!this.errors.any()) {
            this.openConfirmingModal();
          }
        });
      },
      executeBuyToken() {
        if (this.isSubmitting || this.errors.any()) {
          return;
        }

        this.isSubmitting = true;

        const params = {
          currency: this.currentCoin,
          token_amount: this.tokenValue,
        };

        rf.getRequest('ConversionRequest').create(params)
          .then(() => {
            this.$toasted.show(this.$t('dashboard.buy.success'), {
              theme: 'bubble',
              position: 'bottom-right',
              className: 'vue-toasted-success',
              duration : 2000
            });
            this.isSubmitting = false;
          })
          .catch((error) => {
            this.isSubmitting = false;
            Object.keys(error.errors).forEach((key) => {
              this.errors.add({
                field: key,
                msg: error.errors[key][0]
              });
            });
          });
      },
      openConfirmingModal() {
        const callback = this.executeBuyToken.bind(this);
        const currency = this.currentCoin;
        const token_amount = this.tokenValue;
        this.$broadcast('open-modal', BuyTokenConfirmModal, { callback, currency, token_amount });
      },
      validateBalance() {
        if (!BigNumber(this.currencyValue).lte(this.currentWallet.available_balance || 0)) {
          this.errors.add({
            field: 'currency_amount',
            msg: this.$t('validation.insufficient_balance'),
          });
        }
      }
      //FORM SUBMITING - END
    },
    mounted() {
      const currency = this.$route.query.currency;
      const foundIndex = this.listCoin.findIndex(coin => coin.name === currency);
      if (foundIndex !== -1) {
        this.selectCoin(foundIndex);
      }
    },
  }
</script>

<style lang="scss" scoped>
  @import '../../../../sass/variables';
  @import '../../../../sass/vendor/position';

  .buy-heta {
    width: 580px;
    margin: 0 auto;
    padding: 44px 54px 47px;
    background-color: $bg_thin_gray;
    box-shadow: 0 0 70px 0 rgba(0, 0, 0, 0.6);
    border-radius: 10px;
  }

  .list-coin {
    text-align: center;
    margin-bottom: 30px;

    .coin-item {
      cursor: pointer;
      width: 90px;
      padding: 7px 0;
      text-align: center;
      display: inline-block;
      background-color: #e3e3e3;
      border-radius: 30px;
      
      &:not(:last-child) {
        margin-right: 10px;
      }

      &.active {
        background-color: $dark_orange;
        .coin__name {
          color: $white;
        }
      }
    }
    
    .coin__image {
      margin-right: 10px;
      width: 20px;
      height: 20px;
    }

    .coin__name {
      text-transform: uppercase;
      color: $black;
      font-size: $small;
      font-weight: bold;
    }
  }

  .exchange-rate-group {
    margin-bottom: 9px;
    padding: 0 30px;

    &:after {
      content: '';
      display: table;
      clear: both;
    }

    .content-right {
      float: right;
      text-align: right;
    }

    .content-left {
      float: left;
    }
  }

  .buy-heta__input-wrapper {
    position: relative;
    margin-bottom: 14px;

    .buy-heta__input {
      width: 100%;
      opacity: 0.5;
      border-radius: 70px;
      background-color: $white;
      border: solid 1px #b0b0b0;
      transition: all 0.3s ease-in-out;
      padding: 29px 80px 29px 35px;
      color: #333;
      font-size: $small;


      &:focus {
        border-color: #888;
        opacity: 1;
        outline: none;
      }

      &::placeholder {
        font-size: $small;
        color: #cacaca;
      }
    }

    .unit {
      @include absolute(50%, 35px);
      color: $black;
      font-weight: bold;
      font-size: $font18;
      transform: translateY(-50%);
    }
  }

  .btn-group {
    .btn-item {
      cursor: pointer;
      border-radius: 30px;
      border: solid 1px #d2d1d1;
      text-align: center;
      width: 50px;
      padding: 0 5px;
      transition: all 0.3s ease-in-out;

      &:not(:last-child) {
        margin-right: 5px;
      }

      &.active {
        background-color: #b0b0b0;
        color: #fff;
      }
    }
  }

  .buy-btn {
    display: inline-block;
    text-transform: uppercase;
    width: 155px;
    height: 40px;
    font-size: $tiny;
    font-weight: bold;
    line-height: 40px;
    letter-spacing: 0.5px;
    text-align: center;
    color: #fff;
    border-radius: 30px;
    cursor: pointer;
    transition: all 0.3s ease-in-out;
    border: solid 1px #fa7300;
    background: #fa7300;
    &.active,
    &:hover {
      background-color: #da6400;
      color: $white;
    }
    &.disabled {
      &:hover{
        background-color: #fa7300;
      }
    }
  }

  .buy-btn-wrapper {
    text-align: center;
    margin-top: 28px;
  }

  .textbox {
    .number {
      font-size: $small;
      font-weight: bold;
      color: $black;
    }

    .text {
      font-size: $small;
      color: $gray;
    }

    .equal {
      color: $gray;
    }
  }

  .expression {
    padding: 0 30px;
    .number {
      font-size: $small;
      font-weight: bold;
      color: $black;
    }
  }

  .fz-18 {
    font-size: 18px !important;
  }

  .invalid-feedback {
    margin-bottom: 13px;
    padding: 0 30px;
  }

  .disabled {
    cursor: not-allowed !important;
    opacity: .65 !important;
  }

</style>